/*provides a defeasible reasoning service based on DR-DEVICE
 *Respondes via ACL messages that tranfer either paths/URLs or even String content
 * This agent receives REQUEST and respondes with INFORM
 *Mention that is can handle either local paths or URLs (input)
 */

/**
 *
 * @author kalliopi kravari
 * 12/2/2009
 * update: 24/11/2010
 */
//--------AGENTS-----------
import jade.core.*;
import jade.domain.*;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;
import jade.domain.FIPAAgentManagement.*;
//---------JAVA------------
import java.io.*;
import java.net.*;
import java.lang.Runtime;
import org.w3c.dom.*;
import org.w3c.dom.Node;
import javax.xml.parsers.*;
import org.xml.sax.InputSource;
import com.sun.org.apache.xml.internal.serialize.OutputFormat;
import com.sun.org.apache.xml.internal.serialize.XMLSerializer;
import java.util.*;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;

public class ReasoningAgentRR extends jade.core.Agent {

    private String export, req, str, param;//param-> parameters' values
    private String projectName;
    private String address = "http://155.207.113.24:8080/";
    private AID sender;
    private String rulemlContent; //ACLMessage's content - received (ruleml)
    public boolean local = true;
    private Integer isPublic = 0;
    private Document doc;
    private String agentType = "";
    private String system = "dr-device";
    private String debug = "(set-debug on)";
    private String verbose = "(set-verbose on)";
    private String time_report = "(set-time-report off)";
    private String compact_proofs = "(set-compact-proofs on)";
    private String export_non_proved = "(set-export-non-proved off)";
    private String namespace_hunting = "(set-namespace-hunting on)";
    private final String CONFLICTS_FILE = "conflicts.ini";
    private final String PATH = "C:\\Program Files\\DR-Device\\bin";
    private String xsltFileName1 = "C:/Program Files/Apache Software Foundation/Tomcat 6.0/webapps/EMERALDfiles/core/dr-device-output.xslt";

    @Override
    protected void setup() {

        System.out.println("Agent " + getLocalName() + " waiting for requests...");

        //Register the Reasoner service in the yellow pages
        DFAgentDescription dfd = new DFAgentDescription();
        dfd.setName(getAID());
        ServiceDescription sd = new ServiceDescription();
        sd.setType("Defeasible_Reasoning_Service");
        sd.setName("Defeasible_Reasoning_Service");
        dfd.addServices(sd);
        try {
            DFService.register(this, dfd);
            System.out.println("Reasoner: Registration is done!!");
            System.out.println("Type: Defeasible_Reasoning_Service");
        } catch (FIPAException fe) {
            fe.printStackTrace();
        }


        // ADD HANDLEINFORMBEHAVIOUR
        addBehaviour(new HandleInformBehaviour(this));
    }

    class HandleInformBehaviour extends CyclicBehaviour {

        public HandleInformBehaviour(Agent a) {
            super(a);
        }
        //receives and handles ACL messages
        public void action() {
            ACLMessage msg = receive();
            if (msg != null) {
                ACLMessage reply = msg.createReply();
                sender = msg.getSender();
                if (msg.getPerformative() == ACLMessage.REQUEST) {
                    System.out.print("Reasoner: Rulebase received..");
                    rulemlContent = msg.getContent();
                }
                if (msg.getPerformative() == ACLMessage.INFORM) {
                    System.out.print("Reasoner: Settings received..");
                    param = msg.getContent();

                    String rec;
                    Vector<String> vect = new Vector<String>();
                    try {
                        File f = new File(param);
                        FileInputStream fis = new FileInputStream(f);
                        BufferedInputStream bis = new BufferedInputStream(fis);
                        DataInputStream dis = new DataInputStream(bis);

                        while ((rec = dis.readLine()) != null) {
                            vect.add(rec);
                        }
                        for (int n = 0; n < vect.size(); ++n) {
                            String serv = (String) vect.get(n);
                            //  System.out.println(":::::::::"+ serv);
                            if (serv.contains("set-debug")) {
                                debug = serv;
                                System.out.println("::::::::: debug: " + debug);
                            }
                            if (serv.contains("set-verbose")) {
                                verbose = serv;
                                System.out.println("::::::::: verbose: " + verbose);
                            }
                            if (serv.contains("set-time-report")) {
                                time_report = serv;
                                System.out.println("::::::::: time_report: " + time_report);
                            }
                            if (serv.contains("set-compact-proofs")) {
                                compact_proofs = serv;
                                System.out.println("::::::::: compact_proofs: " + compact_proofs);
                            }
                            if (serv.contains("set-export-non-proved")) {
                                export_non_proved = serv;
                                System.out.println("::::::::: export_non_proved: " + export_non_proved);
                            }
                            if (serv.contains("set-namespace-hunting")) {
                                namespace_hunting = serv;
                                System.out.println("::::::::: namespace_hunting: " + namespace_hunting);
                            }
                        }
                    } catch (Exception exception) {
                    }
                } else {
                    //  reply.setPerformative(ACLMessage.NOT_UNDERSTOOD);
                   //  reply.setContent("(Unexpected-act " + ACLMessage.getPerformative(msg.getPerformative()) + ")" + "Expected REQUEST! " + "Try Again!!");
                  //  send(reply);
                }

                //request process....
                if (rulemlContent != null) {
                    projectName = "project" + randomString();
                    System.out.println("Project Name: " + projectName);

                    makeDir(); // Create project workspace (directory)

                    //if the request is a url that indicates a Ruleml fiel and not a locally saved file
                    if (rulemlContent.matches("(?i).*http.*")) {
                        System.out.println("URL provided..");
                        String temppath = fileDownload(rulemlContent, "C:\\jade\\EMERALD\\conclusions");
                        req = fileToString(temppath);
                        isPublic = 1;

                    }
                    //local path provided
                    else{
                     req = fileToString(rulemlContent);
                   }
                   createRbFile(req);  // Creates a backup of the file (locally stored)

                    writeToFile();
                    runBat(projectName);

                    File file = new File("C:\\Program Files\\DR-Device\\projects/" + projectName + "/" + "export.rdf");
                    while (!file.exists()) {
                    }
                    while (file.length() == 0) {
                    }
                    boolean test = true;
                    while (test) {
                        long size1, size2;
                        size1 = file.length();
                        try {
                            Thread.sleep(500);
                        } catch (InterruptedException ie) {
                        }
                        size2 = file.length();
                        if (size1 == size2) {
                            test = false;
                        }
                    }

                    String exportRDF = rdfFileContent();//Reads the export.rdf file
                    export = backupRDF(exportRDF);//Creates a local saved backup and returns its path (rdf file)
                    if (isPublic == 1) {
                        // XSL Transformation: Creates output RuleML document
                        String outputRulemlPath = "C:\\jade\\EMERALD\\conclusions\\" + "output-" + projectName + ".ruleml";
                        XSLTtransform(export, xsltFileName1, outputRulemlPath);
                        String outputRuleml = fileToString(outputRulemlPath);
                        
                        //send output ruleml (as string)
                        ACLMessage message = new ACLMessage(ACLMessage.INFORM);
                        message.addReceiver(sender);
                        message.setLanguage("English");
                        message.setContent(outputRuleml);
                        send(message);
                        System.out.println("Reasoner: Result send..");
                        isPublic =0;
                    } else {                       
                        //send export.rdf (local url) 
                        ACLMessage message = new ACLMessage(ACLMessage.INFORM);
                        message.addReceiver(sender);
                        message.setLanguage("English");
                        message.setContent(export);
                        send(message);
                        System.out.println("Reasoner: Result send..");

                    }
                    
                }

            } else {
                block();
//               System.out.println("This message is empty!!");
                return;
            }

        }
    }
//=================METHODS=======================METHODS===================METHODS========================METHODS=====================//
    // This method creates the directory, where the specific project files will be stored

    private void makeDir() {
        if (projectName.trim().equals("")) {
            System.out.println("The project name field is empty...");
            return;
        } else {
            File file = new File("C:\\Program Files\\DR-Device\\projects/" + projectName);
            try {
                file.mkdirs();
                System.out.println("Done!! Folder " + projectName + " created");
            } catch (Exception e) {
                System.out.println("Could not create project directory");
                return;
            }
        }
    }
//------------------------------------------------------------------------------------------------------//
    // Creates a backup of the rule base

    private void createRbFile(String cont) {

        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            InputSource inputsource = new InputSource();
            inputsource.setCharacterStream(new StringReader(cont));
            doc = builder.parse(inputsource);

            Element root = doc.getDocumentElement();
            root.setAttribute("rdf_export", "export.rdf");

            File file = new File("C:\\Program Files\\DR-Device\\projects/" + projectName + "/" + projectName + ".ruleml");
            FileWriter out = new FileWriter(file);
            OutputFormat oformat = new OutputFormat(doc);
            oformat.setIndenting(true);
            oformat.setIndent(2);
            oformat.setLineWidth(65);
            StringWriter stringOut = new StringWriter();
            XMLSerializer serializer = new XMLSerializer(out, oformat);
            serializer.serialize(doc);
            out.flush();
            out.close();
        } catch (Exception ex) {
            System.out.println("Cannot create rule base file");
            ex.printStackTrace();
            return;
        }
    }
//------------------------------------------------------------------------------------------------------//
    //This method converts the "\" character into "\\". -param s :String - the string that is going to be "transformed" -return result

    public static String transform(String s) {
        StringBuffer sb = new StringBuffer(s);
        String result = "";

        for (int i = 0; i < s.length(); i++) {
            Character c = new Character(sb.charAt(i));
            char cc = c.charValue();
            int nc = (int) cc;

            result = result + "" + c;

            if (nc == 92) {
                result = result + "\\";
            }
        }
        return result;
    }
//------------------------------------------------------------------------------------------------------//
    // Returns a random 4-character string:
    // Characters 1-2 are letters, characters 3-4 are numbers

    private String randomString() {
        java.util.Random random = new java.util.Random();
        String rstr = "";
        for (int j = 0; j < 2; j++) {
            int rand = random.nextInt(25);
            rstr += (char) (97 + rand);
        }
        for (int j = 0; j < 2; j++) {
            int rand = random.nextInt(10);
            rstr += (rand);
        }
        return rstr;
    }
//------------------------------------------------------------------------------------------------------//
    // Transform each element into text and compare the texts

    public String serialize(Node node) {
        StringWriter result = new StringWriter();
        try {
            OutputFormat format = new OutputFormat();
            XMLSerializer serializer = new XMLSerializer(result, format);
            switch (node.getNodeType()) {
                case Node.DOCUMENT_NODE:
                    serializer.serialize((Document) node);
                    break;
                case Node.ELEMENT_NODE:
                    serializer.serialize((Element) node);
                    break;
                case Node.DOCUMENT_FRAGMENT_NODE:
                    serializer.serialize((DocumentFragment) node);
                    break;
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            return "";
        }
        return result.toString().replaceAll("\\s", "");
    }
//------------------------------------------------------------------------------------------------------//
    //This method creates the first .bat files in the relevant directory. return Nothing

    private void writeToFile() {

        ACLMessage msg = new ACLMessage(ACLMessage.INFORM);

        PrintWriter pw = null;
        PrintWriter pw2 = null;

        String url = "C:/Program Files/DR-Device/projects/" + projectName + "/" + projectName + ".ruleml";
        String dir = "(system \"cmd /c echo %dr-device% > current-dir\")\n"
                + "(open \"current-dir\" file \"r\")\n"
                + "(progn\n"
                + "(bind ?dir (readline file))\n"
                + "(open \"run-" + system + ".bat\" run \"w\")\n"
                + "(printout run (str-cat \"(batch* \\\"\" ?dir \"\\\\bin\\\\" + system + ".bat\\\")\") crlf)\n"
                + "(close run)\n"
                + ")\n"
                + "(close file)\n"
                + "(system \"cmd /c \\\"\\\"%dr-device%\\\\bin\\\\repair-path.exe\\\" run-" + system + ".bat\\\"\")\n"
                + "(dribble-on \"" + projectName + ".log\")\n"
                + "(batch* \"run-" + system + ".bat\")\n"
                + "(remove \"current-dir\")\n";

        File file = new File("C:\\Program Files\\DR-Device\\projects/" + projectName + "/" + projectName + ".bat");
        File file2 = new File("C:\\Program Files\\DR-Device\\projects/" + projectName + "/" + "run-" + projectName + ".bat");

        //--------
        try {
            pw = new PrintWriter(new FileOutputStream(file, true));
            pw.print(dir);
            pw.print(verbose + "\n" + debug + "\n" + time_report + "\n" + namespace_hunting + "\n");
//            pw.print("(watch facts)\n");
//            pw.print("(watch rules)\n");
            if (local == false) {
                pw.print("(load-ruleml-" + system + " \"" + projectName + "\" \""
                        + url + "\")" + "\n" + "(dribble-off)\n" + "(exit)" + "\n");
            } else {
                pw.print("(load-ruleml-" + system + "-local \"" + projectName + "\" \""
                        + transform(url) + "\")" + "\n" + "(dribble-off)\n" + "(exit)" + "\n");
            }

            pw2 = new PrintWriter(new FileOutputStream(file2, true));

            pw2.print("@cd %dr-device%\\projects\\" + projectName + "\n");
            pw2.print("@\"%dr-device%\\CLIPSDOS\\CLIPSDOS.exe\" -f2 .\\" + projectName + ".bat\n");
            pw2.print("@pause\nexit\n");
        } catch (IOException ex) {
            System.out.println("An error occured while writing files");
            return;
        } finally {
            pw.close();
            pw2.close();
        }
    }
//------------------------------------------------------------------------------------------------------//

    /**This method creates the first .bat files in the relevant directory.
     * @param projectName :String - the name of the project
     * @return Nothing
     */
    private void runBat(String projectName) {
        ACLMessage msg = new ACLMessage(ACLMessage.INFORM);

        PrintWriter pw = null;
        File file = new File("C:\\Program Files\\DR-Device\\run.bat");
        file.delete();
        try {
            pw = new PrintWriter(new FileOutputStream(file, true));
            pw.print("start projects\\" + projectName + "\\run-" + projectName + ".bat\n");
        } catch (IOException ex) {
            msg.addReceiver(sender);
            msg.setLanguage("English");
            msg.setContent("Could not execute run-" + projectName + ".bat");
            send(msg);
            System.out.println("Could not execute run-" + projectName + ".bat");
            return;
        } finally {
            if (pw != null) {
                pw.close();
            }
        }

        // Execute "run.bat"
        Runtime rt = Runtime.getRuntime();
        try {
            //rt.exec("cmd /c start /B run.bat", null, new File("C:\\Program Files\\DR-Device\\"));//old command
            rt.exec("cmd /c start C:\\Progra~1\\DR-Device\\projects\\" + projectName + "\\run-" + projectName + ".bat");
        } catch (IOException ioe) {
            msg.addReceiver(sender);
            msg.setLanguage("English");
            msg.setContent("Could not execute run.bat");
            send(msg);
            System.out.println("Could not execute run.bat");
            return;
        }

    }
//------------------------------------------------------------------------------------------------------//

    //method rdfFileContent
    private String rdfFileContent() {
//        ACLMessage msg = new ACLMessage(ACLMessage.INFORM);

        File file = new File("C:\\Program Files\\DR-Device\\projects/" + projectName + "/" + "export.rdf");
        Integer length = (int) file.length();

        try {
            byte[] data = new byte[length];
            str = "";
            FileInputStream f = null;
            DataInputStream df = null;
            f = new FileInputStream("C:\\Program Files\\DR-Device\\projects/" + projectName + "/" + "export.rdf");
            df = new DataInputStream(f);
            df.read(data);
            for (int i = 0; i < data.length; i++) {
                str = str + (char) data[i];

            }
            df.close();
            f.close();
        } catch (FileNotFoundException e) {
            System.err.println("There is no such a file...");
        } catch (IOException er) {
        }

        return str;
    }
    //------------------------------------------------------------------------------------------------------//
    // Creates a backup of the rdf

    private String backupRDF(String con) {

        String drpath = "file:/c:/program files/dr-device/export.rdf";
        String path = "file:/c:/jade/EMERALD/conclusions/" + projectName + ".rdf";
        String locpath = "file:/c:/jade/EMERALD/conclusions/" + projectName + ".rdf";

        String newcon = con.replaceAll(drpath, locpath);

        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            InputSource inputsource = new InputSource();
            inputsource.setCharacterStream(new StringReader(newcon));
            Document docum = builder.parse(inputsource);

            // create the conclusions folder if it does not exist
            File fd = new File("C:\\jade\\EMERALD\\conclusions/");
            fd.mkdirs();

            File file = new File("C:\\jade\\EMERALD\\conclusions/" + projectName + ".rdf");
            FileWriter out = new FileWriter(file);
            OutputFormat oformat = new OutputFormat(docum);
            oformat.setIndenting(true);
            oformat.setIndent(2);
            oformat.setLineWidth(65);
            StringWriter stringOut = new StringWriter();
            XMLSerializer serializer = new XMLSerializer(out, oformat);
            serializer.serialize(docum);
            out.flush();
            out.close();

        } catch (Exception ex) {
        }
        return path;
    }

    //------------------------------------------------------------------------------------------------------//
    // Creates a backup of the rdf

    private String backupRDFURL(String con, String address) {

        String drpath = "file:/c:/program files/dr-device/export.rdf";
        String path = address+ "EMERALDfiles/results/" + projectName + ".rdf";
        String locpath = "file:/C:/Program Files/Apache Software Foundation/Tomcat 6.0/webapps/EMERALDfiles/results/" + projectName + ".rdf";

        String newcon = con.replaceAll(drpath, locpath);

        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            InputSource inputsource = new InputSource();
            inputsource.setCharacterStream(new StringReader(newcon));
            Document docum = builder.parse(inputsource);

            // create the conclusions folder if it does not exist
            File fd = new File("C:\\Program Files\\Apache Software Foundation\\Tomcat 6.0\\webapps\\EMERALDfiles\\results/");
            fd.mkdirs();

            File file = new File("C:\\Program Files\\Apache Software Foundation\\Tomcat 6.0\\webapps\\EMERALDfiles\\results/" + projectName + ".rdf");
            FileWriter out = new FileWriter(file);
            OutputFormat oformat = new OutputFormat(docum);
            oformat.setIndenting(true);
            oformat.setIndent(2);
            oformat.setLineWidth(65);
            StringWriter stringOut = new StringWriter();
            XMLSerializer serializer = new XMLSerializer(out, oformat);
            serializer.serialize(docum);
            out.flush();
            out.close();

        } catch (Exception ex) {
        }
        return path;
    }

    //------------------------------------------------------------------------------------------------------//
    //Reads a file and returns it as String

    public String fileToString(String path) {
        String str = "";
        File file = new File(path);
        Integer length = (int) file.length();
        System.out.println("File length:" + file.length());

        try {
            byte[] data = new byte[length];
            FileInputStream f = null;
            DataInputStream df = null;
            f = new FileInputStream(path);
            df = new DataInputStream(f);
            df.read(data);
            for (int i = 0; i < data.length; i++) {
                str = str + (char) data[i];

            }
            df.close();
            f.close();
        } catch (FileNotFoundException e) {

            System.err.println("There is no such a file...");
        } catch (IOException er) {
        }

        return str;
    }
    //=================METHODS=======================METHODS===================METHODS========================METHODS=====================//
    final static int size = 1024;

    public static void fileUrl(String fAddress, String localFileName, String destinationDir) {
        OutputStream outStream = null;
        URLConnection uCon = null;


        InputStream is = null;
        try {
            URL Url;
            byte[] buf;
            int ByteRead, ByteWritten = 0;
            Url = new URL(fAddress);
            outStream = new BufferedOutputStream(new FileOutputStream(destinationDir + "\\" + localFileName));

            uCon = Url.openConnection();
            is = uCon.getInputStream();
            buf = new byte[size];
            while ((ByteRead = is.read(buf)) != -1) {
                outStream.write(buf, 0, ByteRead);
                ByteWritten += ByteRead;
            }
            System.out.println("Downloaded Successfully.");
            System.out.println("File name:\"" + localFileName + "\"\nNo ofbytes :" + ByteWritten);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                is.close();
                outStream.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public static String fileDownload(String fAddress, String destinationDir) {

        int slashIndex = fAddress.lastIndexOf('/');
        int periodIndex = fAddress.lastIndexOf('.');

        String fileName = fAddress.substring(slashIndex + 1);

        if (periodIndex >= 1 && slashIndex >= 0 && slashIndex < fAddress.length() - 1) {
            fileUrl(fAddress, fileName, destinationDir);
        } else {
            System.err.println("path or file name.");
        }
        return destinationDir + "\\" + fileName;

    }
    //=================METHODS=======================METHODS===================METHODS========================METHODS=====================//
// XSL Transformation.

    private void XSLTtransform(String input, String xslt, String output) {
        try {
            // 1. Instantiate a TransformerFactory.
            javax.xml.transform.TransformerFactory tFactory =
                    javax.xml.transform.TransformerFactory.newInstance();

            // 2. Use the TransformerFactory to process the stylesheet Source and
            //    generate a Transformer.
            javax.xml.transform.Transformer transformer =
                    tFactory.newTransformer(
                    new javax.xml.transform.stream.StreamSource(xslt));

            // 3. Use the Transformer to transform an XML Source and send the
            //    output to a Result object.
            transformer.transform(new javax.xml.transform.stream.StreamSource(input),
                    new javax.xml.transform.stream.StreamResult(
                    new java.io.FileOutputStream(output)));

        } catch (Exception e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
        }


    }


}
